<?php  

class MageSage_ProductFeeds_Block_Adminhtml_ProductFeeds extends Mage_Adminhtml_Block_Template {

    /**
     * Get a list of feeds to display in feed listing page.
     * @return array
     */
    public function getFeedsList()
    {
        $feedsModel = Mage::getModel('productfeeds/productfeed');
        $feedsCollection = $feedsModel->getCollection();
        $feedsData = array();
        $i = 0;
        if($feedsCollection->count()) {
            foreach ($feedsCollection as $feed) {
                $feedsData[$i]['id'] = $feed->getId();
                $feedsData[$i]['name'] = $feed->getTitle();
                $feedsData[$i]['local_category'] = $this->getLocalCategories($feed->getCategory());
                $feedsData[$i]['remote_category'] = $feed->getRemoteCategory();
                $feedsData[$i]['type'] = $feed->getType();
                $feedsData[$i]['url'] = $feed->getUrl();
                $feedsData[$i]['modified'] = ($feed->getModified()) ? $feed->getModified() : $feed->getCreated();
                $feedsData[$i]['product_count'] = $feed->getProductCount();
                $i++;
            }
        }
        return $feedsData;
    }


    /**
     * Get category ids and return category names as string
     * @param $categoriesString
     * @return string
     */
    private function getLocalCategories($categoriesString){
        $categories = explode(',', $categoriesString);
        $localCategories = array();
        foreach($categories as $category) {
            if($category) {
                $categoryName = Mage::getModel('catalog/category')->load($category)->getName();
                $localCategories[] = $categoryName;
            }
        }
        $categoriesName = implode(',', $localCategories);
        return $categoriesName;
    }

}