<?php
/**
 * Created by PhpStorm.
 * User: manish
 * Date: 12/9/15
 * Time: 11:32 PM
 */

class MageSage_ProductFeeds_Adminhtml_AjaxfeedController extends Mage_Adminhtml_Controller_Action
{
    private $extensionFolder;

    public function _construct()
    {
        $this->extensionFolder = Mage::getBaseDir('lib') . '/CartProductFeeds/core/';
        require_once $this->extensionFolder . 'data/feedcore.php';
				require_once $this->extensionFolder . 'data/feedfolders.php';
        require_once $this->extensionFolder . 'data/productcategories.php';
				require_once $this->extensionFolder . 'classes/cart-product-feed.php';
        require_once $this->extensionFolder . 'classes/dialogbasefeed.php';
				require_once $this->extensionFolder . 'classes/md5.php';
        require_once $this->extensionFolder . 'classes/providerlist.php';
        require_once $this->extensionFolder . 'classes/dialogfeedsettings.php';
    }

    /**
     * Select feed and display the feed dialog
     */
    public function selectMainFeedAction()
    {
        $feedType = $this->getRequest()->getPost('feedtype');

        if (strlen($feedType) == 0)
            return;

        $inc = $this->extensionFolder. 'feeds/' . strtolower($feedType) . '/dialognew.php';
        $feedObjectName = $feedType . 'Dlg';

        if (file_exists($inc))
            include_once $inc;
        $f = new $feedObjectName();
        echo $f->mainDialog();
    }

		public function getFeedAction() {

			$requestCode = $this->getRequest()->getPost('provider');
			$local_category =	$this->getRequest()->getPost('local_category');
			$remote_category = $this->getRequest()->getPost('remote_category');
			$file_name = $this->getRequest()->getPost('file_name');
			$feedIdentifier = $this->getRequest()->getPost('feed_identifier');
			$saved_feed_id = $this->getRequest()->getPost('feed_id');
			$feed_list = $this->getRequest()->getPost('feed_ids'); //For Aggregate Feed Provider

			require_once $this->extensionFolder . 'data/attributedefaults.php';
			require_once $this->extensionFolder . 'data/feedactivitylog.php';
			require_once $this->extensionFolder . 'data/feedoverrides.php';
			require_once $this->extensionFolder . 'data/productlist.php';
			require_once $this->extensionFolder . 'data/shippingdata.php';
			require_once $this->extensionFolder . 'data/taxationdata.php';
			require_once $this->extensionFolder . 'registration.php';

			$output = new stdClass();
			$output->url = '';

			if (strlen($requestCode) * strlen($local_category) == 0) {
				$output->errors = 'Error: error in AJAX request. Insufficient data or categories supplied.';
				echo json_encode($output);
				return;
			}

			if (strlen($remote_category) == 0) {
				$output->errors = 'Error: Insufficient data. Please fill in "' . $requestCode . ' category"';
				echo json_encode($output);
				return;
			}
			 
			// Check if form was posted and select task accordingly
			$dir = PFeedFolder::uploadRoot();
			if (!is_writable($dir)) {
				$output->errors = "Error: $dir should be writeable";
				echo json_encode($output);
				return;
			}
			$dir = PFeedFolder::uploadFolder();
			if (!is_dir($dir)) {
				mkdir($dir);
			}
			if (!is_writable($dir)) {
				$output->errors = "Error: $dir should be writeable";
				echo json_encode($output);
				return;
			}

			$providerFile = $this->extensionFolder. 'feeds/' . strtolower($requestCode) . '/feed.php';

			//If Feed Provider does not exist, bail
			if (!file_exists($providerFile)) 
				if (!class_exists('P' . $requestCode . 'Feed')) {
					$output->errors = 'Error: Provider file not found.';
					echo json_encode($output);
					return;
				}

			require_once $providerFile;

			//Load form data
			//$file_name = sanitize_title_with_dashes($file_name); //In WordPress, we make sure there's no sneaky-business in the filename
			if ($file_name == '')
				$file_name = 'feed' . rand(10, 1000);

			//Check if user wants us to use an existing feed
			$saved_feed = null;
			if ( (strlen($saved_feed_id) > 0) && ($saved_feed_id > 0) ) { //Note: All other platforms use > -1 but Magento is set to > 0
				require_once $this->extensionFolder. 'data/savedfeed.php';
				$saved_feed = new PSavedFeed($saved_feed_id);
			}

			$providerClass = 'P' . $requestCode . 'Feed';
			$x = new $providerClass;
			$x->feed_list = $feed_list; //For Aggregate Provider only
			if (strlen($feedIdentifier) > 0)
				$x->activityLogger = new PFeedActivityLog($feedIdentifier);
			$x->getFeedData($local_category, $remote_category, $file_name, $saved_feed);

			if ($x->success)
				$output->url = PFeedFolder::uploadURL() . $x->providerName . '/' . $file_name . '.' . $x->fileformat;
			$output->errors = $x->getErrorMessages();

			echo json_encode($output);

		}

		public function getFeedStatusAction() {

			$feedIdentifier = $this->getRequest()->getPost('feed_identifier');
			global $pfcore;
			echo $pfcore->settingGet('cp_feedActivity_' . $feedIdentifier);

		}

    /**
     *  Fetch the local categories to be displayed as the tree structure
     *
     */
    public function fetchLocalCategoriesAction(){
//        define ('XMLRPC_REQUEST', true);
//        ob_start(null);
//        ob_clean();
        $categoryList = new PProductCategories();
        $result = new stdClass();
        $result->children = array();

        foreach($categoryList->categories as $this_category){
            if (!isset($this_category->parent_category))
                $this->processCategory($result->children, $this_category);
        }
        echo json_encode($result);
    }

		public function fetchSelectFeedAction() {

			$feedType = $this->getRequest()->getPost('feedtype');

			if (strlen($feedType) == 0)
				return;

			$inc = $this->extensionFolder. 'feeds/' . strtolower($feedType) . '/dialognew.php';
			$feedObjectName = $feedType . 'Dlg';

			if (file_exists($inc))
				include_once $inc;
			$f = new $feedObjectName();
			echo $f->mainDialog();

		}

		public function fetchTemplateDetailsAction() {

			//fetchTemplateDetails() used By Amazon and other Providers who need templates
			require_once $this->extensionFolder . 'data/feedcore.php';
			require_once $this->extensionFolder . 'classes/dialogbasefeed.php';
			require_once $this->extensionFolder . 'classes/providerlist.php';

			$feedType = $this->getRequest()->getPost('provider'); //ex: 'kelkoo', 'amazonsc';
			$category = $this->getRequest()->getPost('template');

			if (strlen($feedType) == 0)
				return;

			$inc = dirname(__FILE__) . '/../../feeds/' . strtolower($feedType) . '/dialognew.php';
			$feedObjectName = $feedType . 'Dlg';

			include_once $inc;
			$f = new $feedObjectName();
			$f->initializeProvider();
			$f->provider->initializeFeed($category, $category);
			echo $f->attributeMappings();

		}

    private function processCategory(&$target_list, $this_category) {
        $new_category = new stdClass();
        $new_category->id = $this_category->id;
        $new_category->title = $this_category->title;
        $new_category->tally = $this_category->tally;
        $new_category->children = array();
        $target_list[] = $new_category;
        foreach($this_category->children as $child){
            $this->processCategory($new_category->children, $child);
        }
    }

    public function fetchCategoryAction()
    {
        $service_name = $_POST['service_name'];

        $data = '';
        if (class_exists('CPF_Taxonomy'))
            $data = CPF_Taxonomy::onLoadTaxonomy(strtolower($_POST['service_name']));

        if (strlen($data) == 0)
            $data = file_get_contents($this->extensionFolder. 'feeds/' . strtolower($service_name) . '/categories.txt');

        $data = explode("\n", $data);
        $searchTerm = strtolower($_POST['partial_data']);
        $count = 0;
        $canDisplay = true;
        foreach($data as $this_item) {

            if (strlen($this_item) * strlen($searchTerm) == 0)
                continue;

            if (strpos(strtolower($this_item), $searchTerm) !== false) {

                //Transform item from chicken-scratch into something the system can recognize later
                $option = str_replace(" & ", ".and.", str_replace(" / ", ".in.", trim($this_item)));
                $option = str_replace("'", '', $option);

                //Transform a category from chicken-scratch into something the user can read
                $text = htmlentities(trim($this_item));

                if ($canDisplay)
                    echo '<div class="categoryItem" onclick="doSelectCategory(this, \'' . $option . '\', \'' . $service_name . '\')">' . $text . '</div>';
                $count++;
                if ((strlen($searchTerm) < 3) && ($count > 15))
                    $canDisplay = false;

            }
        }

        if ($count == 0) {
            //echo 'No matching categories found';
        }

        if (!$canDisplay)
            echo '<div class="categoryItem">(' . $count . ' results)</div>';

    }

		public function mappingsEraseAction() {

			//This call must clear all attribute mappings for the given provider (eg User has clicked reset mappings)
			require_once $this->extensionFolder . 'data/feedcore.php';

			$providerName = $this->getRequest()->getPost('service_name');

			//$this->getModel() ?
			//Find all & delete:
			//DELETE FROM cpf_options
			//WHERE option_name LIKE '%s'", like_escape($providerName) . '_cp_%');

			echo "1"; //1 = success. 0 = fail
		}

		public function setAttributeOptionAction() {

			$service_name = $this->getRequest()->getPost('service_name');
			$attribute = $this->getRequest()->getPost('attribute');
			$mapto = $this->getRequest()->getPost('mapto');
			$option_name = $service_name . '_cp_' . $attribute;

			//$this->getModel() ?
			//Load the CPF_option matching $option_name:
			//SELECT id FROM CPF_options WHERE name = ' . $option_name

			//Update the option:
			//UPDATE CPF_options set value=$mapto WHERE id=$id

		}

		public function setAttributeUserMapAction() {

			$service_name = $this->getRequest()->getPost('service_name');
			$attribute = $this->getRequest()->getPost('attribute');
			$mapto = $this->getRequest()->getPost('mapto');

			//$option_name = $service_name . '_cp_' . $attribute;
			$map_string_name = 'cpf_attribute_user_map_' . $service_name;

			//Load the CPF option matching $map_string_name. This should be a json-array string
			//$this->model->get
			//SELECT id FROM CPF_options WHERE name = ' . $option_name
			//$user_map = (value)

			if (strlen($user_map) == 0)
				$map = array();
			else {
				$map = json_decode($user_map);
				$map = get_object_vars($map);
			}

			$map[$mapto] = $attribute;

			if ($attribute == '(Reset)') {
				$new_map = array();
				foreach($map as $index => $item)
					if ($index != $mapto)
						$new_map[$index] = $item;
				$map = $new_map;
			}

			//Save
			//$this->model->save

		}

		public function updateAllFeedsAction() {

			//I don't think Magento has an "update all" concept, so this function will probably never get called
			echo "0";

		}

		public function updateSettingAction() {

			//This function is a little messy because it serves two roles.
			//primary role is to save a setting the user clicked in the form
			//the secondary role is to store the "Advanced Commands" with is a variable-length string that must be preserved accurately

			require_once $this->extensionFolder . 'data/feedcore.php';
			require_once $this->extensionFolder . 'data/savedfeed.php';
			$setting = $this->getRequest()->getPost('setting');
			$value = $this->getRequest()->getPost('value');
			$feedID = $this->getRequest()->getPost('feed_id');
			$target = '';

			//Some versions of PHP don't return the post correctly when it's long data
			if (strlen($setting) == 0) {
				$setting = substr(file_get_contents("php://input"), 8);
				$indexOfAmp = strpos($setting, '&value');
				if ($indexOfAmp !== false)
					$setting = substr($setting, 0, $indexOfAmp);
			}

			global $pfcore;

			//The two roles come into play here. Primary role: Set a setting. Secondary: Set Advanced Commands

			if (strpos($setting, 'cp_advancedFeedSetting') !== false) {	//Advanced Command

				//$value may get truncated on an & because $_POST can't parse. Pull value manually
				$postdata = file_get_contents("php://input");
				$i = strpos($postdata, '&');
				if ($i !== false)
					$postdata = substr($postdata, $i + 7);

				//Strip the provider name out of the setting
				//echo $postdata;
				$target = substr($setting, strpos($setting, '-') + 1);
				$setting = $target  . '-cart-product-settings';

				if ($feedID == 0) {
					$pfcore->settingSet($setting, $value);
				} else {
					$saved_feed = new PSavedFeed($feedID);
					$saved_feed->save_ownoverrides($value);
				}

			} else
				$pfcore->settingSet($setting, $value); //Primary role

			//Cleanup
			echo 'Updated.';


		}

}