<?php
$installer = $this;
$optionsTable = $installer->getTable('productfeeds/feedoptions');
$feedsTable = $installer->getTable('productfeeds/productfeed');
$installer->startSetup();
$sql=<<<SQLTEXT
CREATE TABLE IF NOT EXISTS `{$optionsTable}` (
	id int AUTO_INCREMENT,
	name varchar(255),
	value text,
	kind int,
	ordering int,
	created datetime,
	created_by int,
	catid int,
	checked_out int(11) default 0,
	checked_out_time datetime,
	publish_down datetime,
	publish_up datetime,
	modified datetime,
	modified_by int,
	access int(11) default 1,
	state tinyint(1) default '1',
	language char(7) default '*',
	PRIMARY KEY (`id`)
) DEFAULT CHARSET utf8 DEFAULT COLLATE utf8_general_ci;

CREATE TABLE IF NOT EXISTS `{$feedsTable}` (
	id int AUTO_INCREMENT,
	title varchar(255),
	description text,
	category varchar(250),
	remote_category varchar(1000),
	filename varchar(250),
	url varchar(500),
	type varchar(50) DEFAULT 'google',
	own_overrides int,
	feed_overrides text,
	product_count int,
	ordering int,
	created datetime,
	created_by int,
	catid int,
	checked_out int(11) default 0,
	checked_out_time datetime,
	publish_down datetime,
	publish_up datetime,
	modified datetime,
	modified_by int,
	access int(11) default 1,
	state tinyint(1) default '1',
	language char(7) default '*',
	PRIMARY KEY (`id`)
) DEFAULT CHARSET utf8 DEFAULT COLLATE utf8_general_ci ;
		
SQLTEXT;

$installer->run($sql);
$installer->endSetup();
	 